/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2021
 * ESP32 - SENSORES
*/


#define IP_STATIC

#define SEGUNDO 50
#define TSERVER 25
#define TREFRES 18000
#define TSENSOR 300
#define TBMP 100


#define PIN_LED 2

//____________IP____________
#include <WiFi.h>

char mibufferIP[20];

const char* ssid       = "contraseña";
const char* password   = "nombreDeModem";
const char* ntpServer = "pool.ntp.org";
const long  gmtOffset_sec = 3600;
const int   daylightOffset_sec = 3600;

#if defined IP_STATIC
    // Set your Static IP address
    IPAddress local_IP(192, 168, 1, 150);
    // Set your Gateway IP address
    IPAddress gateway(192, 168, 1, 1);    
    IPAddress subnet(255, 255, 0, 0);
    IPAddress primaryDNS(8, 8, 8, 8);   //optional
    IPAddress secondaryDNS(8, 8, 4, 4); //optional
#endif

//___________18B20__________
#include <OneWire.h>
#define PIN_18B20  0
OneWire ds(PIN_18B20); // pin utilizado para el bus Onewire
int Otemperatura;
int getTemp(void);
char mibuffer18B20[25];
void getTempera18B20(void);

//____________LUZ___________
#define PIN_LUZ  34 //GPIO34
int Oluz;
char mibufferLuz[25];

//____________TEMPERATURA  - HUMEDAD ___________
#include "DHT.h"
#define PIN_DHT 4 
//#define DHTTYPE DHT11   // DHT 11 
#define DHTTYPE DHT22   // DHT 22  (AM2302)
//#define DHTTYPE DHT21   // DHT 21 (AM2301)
DHT dht(PIN_DHT, DHTTYPE);
float h,t; 
char mibufferTemperatura[100];

//___________OLED_________
#include "olex.h"
#include <Wire.h>
//___________TIME_________
#include "time.h"
struct tm timeinfo;
char mibufferTime[50];
char mibufferDate[50];

//___________BMP180________
#define BMP180_ADDR 0x77 // 7-bit address

#define  BMP180_REG_CONTROL 0xF4
#define BMP180_REG_RESULT 0xF6
#define BMP180_COMMAND_TEMPERATURE 0x2E

int16_t AC1,AC2,AC3,VB1,VB2,MB,MC,MD;
uint16_t AC4,AC5,AC6; 
unsigned char _error;

int32_t Temperatura,Presion,PresionBase;
unsigned char mibufferU[10];
char mibuffer[20];

// altura en Palencia
#define ALTURA 790

char L1_presion[25];
char L2_presion[25];
char L3_presion[25];

//_____HX711______________

#include "HX711.h"
const int DOUT=16;
const int CLK=17;
HX711 balanza;

float peso;
#define AJUSTE 1977700
char L4_peso[25];



//___________SERVER_________
#include <WebServer.h>
#include <ESPmDNS.h>

WebServer server(80);
#define MAXmibuffer2  1500
char mibuffer2[MAXmibuffer2 + 1];
char  Iniciohtml[] = "<!DOCTYPE HTML>\r\n <html><TITLE>SERVER - ESP32 </TITLE> <h1><b>Seta43_ESP32 </b></h1><hr>";
char  Cuerpohtml[] = "<h2> <font color=\"#660000\"><b> Palencia</b></font> </h2>  ";
char  Finhtml[] = " <hr>  seta43.duckdns.org </html>";

void handleRoot() 
  { 
   int z;
    digitalWrite(PIN_LED, 1); 
    strcpy(mibuffer2, Iniciohtml);
    strcat(mibuffer2, Cuerpohtml);
    strcat(mibuffer2, mibufferTime);
    strcat(mibuffer2, mibufferDate);
    strcat(mibuffer2, mibufferTemperatura);
    strcat(mibuffer2, mibuffer18B20);
    strcat(mibuffer2, mibufferLuz);
    strcat(mibuffer2,"<p>BMP180 ");
    strcat(mibuffer2, L1_presion);
    strcat(mibuffer2,"</p>");
    strcat(mibuffer2,"<p>BMP180 ");
    strcat(mibuffer2, L2_presion);
    strcat(mibuffer2,"</p>");
    strcat(mibuffer2,"<p>BMP180 ");
    strcat(mibuffer2, L3_presion);
    strcat(mibuffer2,"</p>");
    strcat(mibuffer2,"<p>HX711 ");
    strcat(mibuffer2, L4_peso);
    strcat(mibuffer2,"</p>");
    strcat(mibuffer2, Finhtml);
    z = strlen(mibuffer2);
    Serial.println(z);
    server.send(z, "text/html", mibuffer2 );     
    delay(75);
    digitalWrite(PIN_LED, 0);
  }

void handleNotFound() 
{  
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for (uint8_t i = 0; i < server.args(); i++) {
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
  }
  server.send(404, "text/plain", message);
}

//_______________END-SERVER_____________________


char VARI[100];
char TITULO[]="SENSORTOTAL";
int time1S=SEGUNDO,timeServer=TSERVER,timeRefres=TREFRES,timeSensor=TSENSOR,timeBMP=TBMP;


void setup() 
{
  Serial.begin(9600);
  Serial.println(TITULO);
  pinMode(PIN_LED, OUTPUT);

  dht.begin();

  OleInit();
  xclearDisplay(); 
  xStringAT(0,3,TITULO);

  //connect to WiFi
#if defined IP_STATIC
    // Configures static IP address
     if (!WiFi.config(local_IP, gateway, subnet, primaryDNS, secondaryDNS)) 
    //  if (!WiFi.config(local_IP, gateway, subnet)) {   Serial.println("STA Failed to configure");    }
#endif
  Serial.printf("Conectando a %s ", ssid);
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) 
    {  delay(500);  Serial.print("."); }
  Serial.print(" Conectado con IP-");  Serial.println(WiFi.localIP() );
 
  configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);

  server.on("/", handleRoot);
  server.onNotFound(handleNotFound);
  server.begin();
  Serial.println("HTTP server started");
  
  /*
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
  */

    startBMP180();
    getBMP180();
    PresionBase=Presion;   
    Serial.print("Presion base: ");
    Serial.print(PresionBase);
    Serial.println(" mb"); 


    balanza.begin(DOUT, CLK);
    Serial.print("Lectura del valor del ADC:t");
    Serial.println(balanza.read());
    Serial.println("No ponga ningún objeto sobre la balanza");
    Serial.println("Destarando...");
    balanza.set_scale(AJUSTE); //La escala por defecto es 1
    balanza.tare(10);  // Establecemos la tara  

  delay(500);
}


void loop() 
{
  delay(20);
  time1S++; timeServer++; timeRefres++,timeSensor++,timeBMP++;
  
  if(time1S>SEGUNDO)
    {
      time1S=0;
      printTime();   
      getLuz();
      getPeso();
    }
    
  if(timeSensor>TSENSOR)
    {
      timeSensor=0;
      getTempera();   
      getTempera18B20();  
    }  
    
  if(timeServer>TSERVER)
    {
      timeServer=0;
      servidor();
    }
    
  if(timeRefres>TREFRES)
    {
      timeRefres=0;
      refresPantalla();
    }

  if(timeBMP>TBMP)
    {
      timeBMP=0;
      getPresion();
    }
    
}




void servidor()
{
   server.handleClient();
}


char *dias[]={"LUNES","MARTES","MIERCOLES","JUEVES","VIERNES","SABADO","DOMINGO"};

void printTime()
{
  if(!getLocalTime(&timeinfo))   { Serial.println("Failed to obtain time"); return;  }
  
  sprintf(VARI,"---  %02d:%02d:%02d  --- ",timeinfo.tm_hour,timeinfo.tm_min,timeinfo.tm_sec);  
  ModeFont=0; xStringAT(0,0,VARI);
  sprintf(mibufferTime,"<p>%s</p>",VARI);
}


void refresPantalla()
{
  xclearDisplay();
  getLuz();
  getTempera();
  sprintf(mibufferIP,"IP-%d.%d.%d.%d",WiFi.localIP()[0],WiFi.localIP()[1],WiFi.localIP()[2],WiFi.localIP()[3] ); 
  ModeFont=0; xStringAT(0,7,mibufferIP);

  sprintf(VARI,"%s %02d-%02d-%02d",dias[timeinfo.tm_wday-1],timeinfo.tm_mday,timeinfo.tm_mon+1,timeinfo.tm_year+1900);
  sprintf(mibufferDate,"<p>%s</p>",VARI);
  ModeFont=0; xStringAT(0,1,VARI); 
}


void printPresion(void)
{
 // xStringAT(0,1,L1_presion); 
  xStringAT(0,5,L2_presion); 
//  xStringAT(0,3,L3_presion);

  Serial.println(L1_presion);
  Serial.println(L2_presion);
  Serial.println(L3_presion); Serial.println();
  
}


//_____________PESO______________

void getPeso(void)
{
 int32_t z;
  peso=balanza.get_units(10);  //numero de lecturas para hacer la media
  z=peso*10000;
  intTOstring(z,4,1); 
  sprintf(L4_peso,"Peso: %s grs  ",mibuffer); 
  xStringAT(0,6,L4_peso); 
  Serial.print(L4_peso); Serial.println();
}



//_____________________18B20__________
void getTempera18B20(void)
{
    if (0 == getTemp())
    {
      Otemperatura = -1000;
      getTemp();
      if (Otemperatura != -1000)
      {
        sprintf(VARI,"18B20: %d.%d C ",Otemperatura/10,Otemperatura % 10);
        Serial.println(VARI);
        ModeFont=0; xStringAT(0,3,VARI);
        sprintf(mibuffer18B20,"<p>18B20: %d.%d &#176;C </p>",Otemperatura/10,Otemperatura % 10);    
      }
    }
}


void getPresion(void)
{
  int z;

  if(getBMP180()){  Serial.print("ERRORES=");  Serial.println(_error);}
    
  intTOstring(Temperatura,5,2);  
  sprintf(L1_presion,"T: %s C",mibuffer);  
  
  z=Presion/100;
  intTOstring(z,5,0); 
  //sprintf(L2_presion,"P: %s mb",mibuffer);   
  sprintf(L2_presion,"P: %d mb ",z);   
 
  z=DifAltitud(Presion,PresionBase);
  intTOstring(z,5,2); 
  sprintf(L3_presion,"L: %s metros",mibuffer);  

  printPresion();
}





void getTempera()
{
  h = dht.readHumidity();
  t = dht.readTemperature();
  if (isnan(h) || isnan(t)) 
    { Serial.println(F("ERROR DHT sensor!"));  return; }

  sprintf(VARI,"%3.1f C .... %2.0f%%",t,h);
  Serial.println(VARI);
  ModeFont=0; xStringAT(0,4,VARI);
  sprintf(mibufferTemperatura,"<p>AM2302 Temperatura= %3.1f &#176;C </p> <p>AM2302 Humedad= %2.0f%% </p>",t,h);
}




void getLuz()
{
  Oluz = analogRead(PIN_LUZ);
  sprintf(VARI,"Luz:%d      ",Oluz);
  Serial.println(VARI);
  ModeFont=0; xStringAT(0,2,VARI);
  sprintf(mibufferLuz,"<p>Luz: %d</p>",Oluz);
}


//______________________________________________________
//ds18B20

int getTemp(void)
{
  byte data[12];
  byte addr[8];
  int z;
  long  temp;
  // byte decimal;


  if ( !ds.search(addr))  { ds.reset_search();  return 0;  }
  if ( OneWire::crc8( addr, 7) != addr[7]) ;// { SERIECONSOLA.println(F("CRC is not valid!")); return -1; }
  if ( addr[0] != 0x10 && addr[0] != 0x28) ;// { SERIECONSOLA.print(F("Device is not recognized")); return -1; }

  ds.reset();  ds.select(addr);  ds.write(0x4E);
  ds.write(0x4B);
  ds.write(0x46);
  ds.write(0x7F);    // 12-bit sampling resolution (default)
  //ds.write(0x5F);    // 11-bit
  //ds.write(0x3F);    // 10-bit
  //ds.write(0x1F);    // 9-bit
  // delay(500);

  ds.reset();  ds.select(addr);  ds.write(0x44, 1); // start conversion, with parasite power on at the end
  delay(750);

  ds.reset();  ds.select(addr);  ds.write(0xBE); // Read Scratchpad
  for ( z = 0; z < 9; z++) data[z] = ds.read();

  z = (data[1] << 8) | data[0];
  temp = z;
  temp = (temp * 625) / 1000;
  Otemperatura = temp;
  return 1;
}







//____BMP180________________________________

int DifAltitud(long Pres,long PresBase)
{
 long z,zz;
   
   z=PresBase-Pres;
   z*=904;
   z/=100;     
   return((int)z);  
}

//_SETA43_____

int MiLecturaI(char address)
{
  char x;
  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(address);
  if(Wire.endTransmission()) Serial.print("ERROR ");
  
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++)  mibufferU[x] = Wire.read();
  return( (((int)mibufferU[0]<<8)|(int)mibufferU[1]) ); 
}  


char startBMP180(void)
{
  Wire.begin();      
  AC1=MiLecturaI(0xAA);
  AC2=MiLecturaI(0xAC);
  AC3=MiLecturaI(0xAE);
  AC4=MiLecturaI(0xb0);
  AC5=MiLecturaI(0xb2);
  AC6=MiLecturaI(0xb4);
  VB1=MiLecturaI(0xb6);
  VB2=MiLecturaI(0xb8);
  MB=MiLecturaI(0xba);
  MC=MiLecturaI(0xbc);
  MD=MiLecturaI(0xbe);
}


char getBMP180(void)
{
  char x;
  long x1,x2,x3,mtu,mpu,b5,b6,b3,p;
  unsigned long b4,b7;
  
  _error=0;
   
  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = BMP180_COMMAND_TEMPERATURE;  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(20);
  
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++) mibufferU[x] = Wire.read();
  mtu = mibufferU[0];
  mtu=mtu<<8;
  mtu+=mibufferU[1];  //UT
 Serial.print("mtu=");Serial.print(mtu);

  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = 0x34;  //oss=0
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(26);
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,3);
  while(Wire.available() != 3) ; 
  for(x=0;x<3;x++) mibufferU[x] = Wire.read();  
 // for(x=0;x<3;x++) Serial.println(mibufferU[x]);  
  mpu = mibufferU[0];
  mpu=mpu<<16;
  x1=mibufferU[1];
  x1=x1<<8;
  mpu+=x1;
  mpu+=mibufferU[1];
  mpu=mpu>>8;  //oss=0    UP
  Serial.print("   mpu=");Serial.println(mpu);
     
  x1=mtu-AC6;  x1*=AC5;  x1=x1>>15;
  x2=MC;  x2=x2<<11;  x2/=(x1+MD);
  x1+=x2;
  b5=x1;
  x1+=8;
  x1*=10;
  Temperatura=x1>>4;
  

  b6=b5-4000;
  x1=b6*b6;  x1=x1>>12;  x1=x1*VB2;  x1=x1>>11;
  x2=AC2;  x2=x2*b6; x2=x2>>11;
  x3=x2+x1;
  b3=AC1; b3=b3<<2; b3=b3+x3; b3=b3+2; b3=b3>>2;
  x1=AC3; x1*=b6;  x1=x1>>13;
  x2=b6*b6; x2=x2>>12; x2=x2*VB1; x2=x2>>16;
  x3=x1+x2;  x3=x3+2; x3=x3>>2;
  b4=x3;  b4=b4+32768;  b4=b4*AC4;  b4=b4>>15;
  b7=mpu-b3;  b7=b7*50000;
  if(b7<0x80000000)
    {
      p=b7; p=p<<1; p=p/b4;
    }
    else
    {
      p=b7/b4;  p=p<<1;
    }
  x1=p;  x1=x1>>8;  x1=x1*x1;
  x1=x1*3038;  x1=x1>>16;
  x2=-7357;  x2*=p;  x2=x2>>16;
  x1+=x2;  x1=x1+3791; x1=x1>>4;  p+=x1; 
  Presion=p;
  
return(_error);   
}


//_SETA43__
void intTOstring(int n,unsigned char dig,unsigned char dec)
{
  int z,x,zz;
  char signo;

  zz=0;
  z=10000;
  if(n<0) { signo='-'; n*=-1;}  else  {signo='+'; }
  mibuffer[zz]=signo; zz++;
  for(;z>0;z=z/10)
  {
    x=n/z;
    n=n-(z*x);
    mibuffer[zz]=x+'0';
    zz++;
  }
  mibuffer[zz]=0;
  
  if(dec!=0)
   {
    x=zz+1;
    for(;zz>=0;zz--)
    {
    mibuffer[x]=mibuffer[zz];
    x--;
    if(0==dec) { mibuffer[x]='.'; x--;} 
    dec--;
    }
   }
}
